import React from 'react';
import { FieldMultipleCheckbox } from "./components/FieldMultipleCheckbox";
import { FieldSingleCheckbox } from "./components/FieldSingleCheckbox";
import { useStoreContext } from "./hooks";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/fieldCheckbox.less";
var prefixCls = "".concat(PREFIX_CLS, "-fieldCheckbox");

var FieldCheckbox = function FieldCheckbox(props) {
  var isCheckboxGroup = props.isCheckboxGroup;

  var _useStoreContext = useStoreContext(),
      fieldDragWidth = _useStoreContext.fieldDragWidth;

  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls,
    style: {
      width: "calc(100% - ".concat(fieldDragWidth, "px)")
    }
  }, /*#__PURE__*/React.createElement("p", null, "\u9009\u62E9\u9700\u8981\u663E\u793A\u7684\u8868\u5934\u5B57\u6BB5"), isCheckboxGroup ? /*#__PURE__*/React.createElement(FieldMultipleCheckbox, null) : /*#__PURE__*/React.createElement(FieldSingleCheckbox, null));
};

export default FieldCheckbox;