import React from 'react';
import { FieldSingleDrag } from "./components/FieldSingleDrag";
import { FieldMultipleDrag } from "./components/FieldMultipleDrag";
import { useStoreContext } from "./hooks";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/fieldDrag.less";
var prefixCls = "".concat(PREFIX_CLS, "-fieldDrag");

var FieldDrag = function FieldDrag(props) {
  var isDragGroup = props.isDragGroup;

  var _useStoreContext = useStoreContext(),
      fieldDragWidth = _useStoreContext.fieldDragWidth;

  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls,
    style: {
      width: fieldDragWidth
    }
  }, /*#__PURE__*/React.createElement("p", null, "\u5DF2\u9009\u5B57\u6BB5"), isDragGroup ? /*#__PURE__*/React.createElement(FieldMultipleDrag, null) : /*#__PURE__*/React.createElement(FieldSingleDrag, null));
};

export default FieldDrag;