function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useImperativeHandle, forwardRef } from 'react';
import { PREFIX_CLS } from "../constants/dictionary";
import { StoreContext, useMultipleDataHandle } from "./hooks";
import FieldCheckbox from "./FieldCheckbox";
import FieldDrag from "./FieldDrag";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-fieldSetting");

var FieldSetting = function FieldSetting(props, ref) {
  var columns = props.columns,
      defaultSelectFields = props.defaultSelectFields,
      _props$isCheckboxGrou = props.isCheckboxGroup,
      isCheckboxGroup = _props$isCheckboxGrou === void 0 ? false : _props$isCheckboxGrou,
      _props$isDragGroup = props.isDragGroup,
      isDragGroup = _props$isDragGroup === void 0 ? false : _props$isDragGroup,
      fieldDragWidth = props.fieldDragWidth,
      onOk = props.onOk;
  var data = useMultipleDataHandle(columns || []);
  var selectFields = data.selectFields;

  var contextValue = _objectSpread({
    columns: columns,
    defaultSelectFields: defaultSelectFields,
    fieldDragWidth: fieldDragWidth
  }, data);

  useImperativeHandle(ref, function () {
    return {
      sortOk: sortOk
    };
  });

  var sortOk = function sortOk() {
    return onOk && onOk(selectFields);
  };

  return /*#__PURE__*/React.createElement(StoreContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement(FieldCheckbox, {
    isCheckboxGroup: isCheckboxGroup
  }), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-line")
  }), /*#__PURE__*/React.createElement(FieldDrag, {
    isDragGroup: isDragGroup
  })));
};

export default /*#__PURE__*/forwardRef(FieldSetting);