function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useEffect } from 'react';
import { Tag, Typography } from 'rlj-design';
import { useStoreContext } from "../hooks";
import { PREFIX_CLS } from "../../constants/dictionary";
var LongText = Typography.LongText;
var prefixCls = "".concat(PREFIX_CLS, "-fieldMultiDrag");

var FieldItem = function FieldItem(props) {
  var groupName = props.groupName,
      children = props.children,
      groupId = props.groupId,
      fieldId = props.fieldId;

  var _useStoreContext = useStoreContext(),
      setCheckedValueMap = _useStoreContext.setCheckedValueMap,
      checkedValueMap = _useStoreContext.checkedValueMap;

  var closeTag = function closeTag(id) {
    var _checkedValueMap$get;

    var key = groupId || fieldId;
    var restValue = (_checkedValueMap$get = checkedValueMap.get(key)) === null || _checkedValueMap$get === void 0 ? void 0 : _checkedValueMap$get.filter(function (item) {
      return !item.includes(id);
    });

    if (restValue !== null && restValue !== void 0 && restValue.length) {
      checkedValueMap.set(key, restValue);
    } else {
      checkedValueMap.delete(key);
    }

    setCheckedValueMap(new Map(checkedValueMap));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-item")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-item-title")
  }, groupName), children === null || children === void 0 ? void 0 : children.map(function (_ref) {
    var fieldId = _ref.fieldId,
        fieldName = _ref.fieldName,
        fieldDisabled = _ref.fieldDisabled;
    return /*#__PURE__*/React.createElement(Tag, {
      key: fieldId,
      type: "selected",
      closable: true,
      height: 24,
      disabled: fieldDisabled,
      onClose: function onClose() {
        return closeTag(fieldId);
      },
      style: {
        color: fieldDisabled ? undefined : '#7f7f85',
        marginBottom: 6
      }
    }, /*#__PURE__*/React.createElement(LongText, {
      text: fieldName || '',
      length: 24,
      tooltip: fieldName
    }));
  }));
};

export var FieldMultipleDrag = function FieldMultipleDrag() {
  var _useStoreContext2 = useStoreContext(),
      defaultSelectFields = _useStoreContext2.defaultSelectFields,
      selectFields = _useStoreContext2.selectFields,
      setCheckedValueMap = _useStoreContext2.setCheckedValueMap,
      checkedValueMap = _useStoreContext2.checkedValueMap;

  useEffect(function () {
    if (!defaultSelectFields) return;
    defaultSelectFields.forEach(function (item) {
      var children = item.children,
          groupId = item.groupId,
          fieldId = item.fieldId;
      var key = groupId || fieldId;
      (children === null || children === void 0 ? void 0 : children.length) && checkedValueMap.set(key, children === null || children === void 0 ? void 0 : children.map(function (_ref2) {
        var fieldId = _ref2.fieldId;
        return fieldId;
      }));
    });
    setCheckedValueMap(new Map(checkedValueMap));
  }, [defaultSelectFields]);
  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, selectFields === null || selectFields === void 0 ? void 0 : selectFields.map(function (item) {
    return /*#__PURE__*/React.createElement(FieldItem, _extends({
      key: item.groupId || item.fieldId
    }, item));
  }));
};